program RecordsDemo;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Marco.Records in 'Marco.Records.pas',
  Marco.ClassSpeed in 'Marco.ClassSpeed.pas',
  Marco.RecordSpeed in 'Marco.RecordSpeed.pas';

var
  myrec: TMyRecord;
  another: TAnotherRecord;
  t: DateTime;
  ms: Integer;

begin
  myrec := TMyRecord.Create ('hello');
  myrec.Print;

  another.Init (100);
  another.Print;

  t := Now;
  writeln (FloatToStr (Marco.RecordSpeed.ComputeAverageDistance));
  ms := MilliSecondsBetween (Now, t);
  writeln (IntToStr (ms));

  t := Now;
  writeln (FloatToStr (Marco.ClassSpeed.ComputeAverageDistance));
  ms := MilliSecondsBetween (Now, t);
  writeln (IntToStr (ms));

  readln;
end.
