unit InterfaceClasses;

interface

uses
  Classes, System.Runtime.InteropServices;

type
  [Guid('6F1B5589-3987-4665-9C4F-630287760BE9')]
  ISimple = interface (IInterface)
    // ['{6F1B5589-3987-4665-9C4F-630287760BE9}']
    procedure ShowMessage;
    function Compute (a, b: Integer): Integer;
    function get_Value: Integer;
    procedure set_Value (Value: Integer);
    property Value: Integer read get_Value write set_Value;
  end;

  TSimple = class (TObject, ISimple)
  private
    FValue: Integer;
  protected
    function get_Value: Integer;
    procedure set_Value (aValue: Integer);
  public
    procedure ShowMessage;
    function Compute (a, b: Integer): Integer;
  end;

implementation

uses
  SysUtils;

{ TSimple }

function TSimple.Compute(a, b: Integer): Integer;
begin
  Result := a + b;
end;

function TSimple.Get_Value: Integer;
begin
  Result := FValue;
end;

procedure TSimple.Set_Value(aValue: Integer);
begin
  fValue := aValue;
end;

procedure TSimple.ShowMessage;
begin
  writeln ('a message: [' + IntToStr (fvalue) + ']');
end;

end.
