program UnsafeTest;

{$APPTYPE CONSOLE}

// {$UNSAFECODE ON}

uses
  SysUtils, System.Runtime.InteropServices;

// variant record
type
  TFlexi = record
  public
    value: integer;
    case test: Boolean of
      true: (c1: Char; c2: Char);
      false: (n: Integer);
  end;

  TFlexi2 = record
  public
    value: integer;
    case test: Boolean of
      true: (s: string);
      false: (n: Integer);
  end;

  arrayofchar = array of WideChar;

var
  test: string;
  n: Integer;
  obj: TObject;
  //
  ptest2: arrayofchar;


procedure UnsafeParam (var param);
begin
  writeln (tObject(param).ToString);
end;

procedure UseVariantRecord; 
var
  flexi: TFlexi;
begin
  writeln ('using variant record');
  flexi.test := true;
  flexi.c1 := 'a';
  flexi.c2 := 'b';
  flexi.test := false;
  writeln (IntToStr (flexi.n));
end;

{procedure testpchar; // unsafe;
var
  ptest: PChar;
begin
  ptest := @ptest2 [5];
  ptest^ := 'd';
  writeln (ptest2 [5]);
end;}

{procedure PinDownObj (obj: TObject); unsafe;
var
  handle: GCHandle;
  pt: pointer;
  iptr: IntPtr;
begin
  handle := GCHandle.Alloc (obj);
  iptr := handle.AddrOfPinnedObject;
  pt := pointer (iptr);
  // and now?
  // pt^ := ???;
end;}

begin
  try
    test := 'foo';
    UseVariantRecord;

    UnsafeParam (test);
    n := 23;
    UnsafeParam (n);
    obj := TObject.Create;
    UnsafeParam (obj);

    // PinDownObj (obj);

    ptest2 := New (arrayofchar, 100);
    // testpchar;

  except on E: Exception do
    writeln (E.message);
  end;
  readln;
end.
